''***************************
''* Propeller Template V1.0 *
''*  Author: Peter Quello   *
''*  Started: 18 JUN 2006   *
''*  Updated: 23 MAR 2007   *
''***************************
                                                               
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
                          
VAR
  byte x, buff[64], dats[8], idx
OBJ
  term  :       "serial_terminal"
PUB Start
  dats[0] := @_1
  dats[1] := @_2
  dats[2] := @_3
  dats[3] := @_4
  dats[4] := @_5
  dats[5] := @_7
  term.start
  term.out(12)
  term.str(string("Propeller Serial Communications Test"))
  pause(2000)
  term.out(12)
  repeat until passcode
  term.out(13)                                  
  term.str(string("Passcode correct."))         
  pause(1000)                                   
  term.out(12)                                  
                                                    
  repeat                                        
    x := term.getc                                                                        
    case x                                                                                
      8:                                                                                  
        term.out(8)                                                                       
      9:                                                                                  
        term.out(9)                                                                       
      13:                                                                                 
        term.out(13)                                                                      
      27:                                       
        x := term.getc                                                                    
        case x                                                                            
          91:                                                                             
            x := term.getc                      
            arrows                              
            if x == 72
              term.out(12)                          
              term.out(">")                     
              case questions                     
                0:                              
                  term.str(@answer1)            
                1:                              
                  term.str(@answer2)            
                2:                              
                  term.str(@answer3)            
                3:                              
                  term.str(@answer4)
                4:
                  term.str(@answer5)
                5:
                  reboot  'It won't reboot!
                                                                                  
            if x == 75                                                                        
              shutdown                          

        if x == 79                                                                        
          x := term.getc                                                                  
          functions
      43:                                                                                 
        term.out(12)                                                                      
      other:                                                                              
        term.out(x)                            
                                                    
PRI Questions
  readline(@buff, 64)
  repeat idx from 0 to 5
    if strcomp(dats[idx], @buff)
      term.out(13)
      return idx

PRI Arrows
  case x                                                                          
    65:                                                                           
      term.str(string("Up"))                                                      
      term.out (13)                                                               
    66:                                                                           
      term.str(string("Down"))                                                    
      term.out(13)                                                                
    67:                                                                           
      term.str(string("Right"))                                                   
      term.out(13)                                                                
    68:                                                                           
      term.str(string("Left"))                                                    
      term.out(13)
  return

PRI Functions
  case x                                                                          
    80:                                                                                                                                         
      term.str(@hlp)                                                                                              
      term.out(13)                                                                                                                              
    81:                                                                                                                                         
      term.str(@tutor)                                                                  
      term.out(13)                                                                                                                              
    82:                                                                                                                                         
      term.str(string("F3"))                                                                                                                    
      term.out(13)                                                                                                                              
    83:                                                                                                                                         
      term.str(string("F4"))                                                                                                                    
      term.out(13)                                                                                                                              
  return
    
PRI Passcode
  term.str(string("Enter passcode: "))
  readpasscode(@buff, 64)
  if strcomp(@buff, @_passcode)
   return true
  term.str(string(13, "Passcode incorrect."))
  return false
  
PRI ReadPasscode(bufPtr, bufSize) | c
' bufPtr is the address of a buffer (byte array)
' bufSize is the length of the buffer
    repeat
      c := term.getc
      if c == 13 or bufSize == 0
          byte[bufPtr++] := 0
          return
      byte[bufPtr++] := c
      term.out("*")
      bufSize--
        
PRI ReadLine(bufPtr, bufSize) | c
' bufPtr is the address of a buffer (byte array)
' bufSize is the length of the buffer
    repeat
      c := term.getc
      term.out(c)
      if c == 13 or bufSize == 0
          byte[bufPtr++] := 0
          return
      byte[bufPtr++] := c
      'term.out(c)
      bufSize--

PRI ShutDown
  term.out(12)
  term.str(string("Are you sure?"))
  term.out(13)
  term.out(">")                                           
  x := term.getc
  term.out(x)                                                              
  case x
    121:                                                                                 
      term.out(13)                                                                              
      term.str(string("Shutting down"))                                                         
      pause(500)                                                                                
      repeat 5                                                                                  
        term.out(".")                                                                           
        pause(1000)                                                                              
      term.out(13)                                                                              
      term.str(string("It is now safe to turn off your Propeller."))
      repeat
    110:
      term.out(12)
      return
                      
PRI Pause(ms) | clkcycles, milisec
  waitcnt(clkfreq / 1000 * ms + cnt)
  return

DAT
_passcode     byte      "robogeek", 0

_1      byte  "how are you?",0
answer1 byte  "I am fine.",0

_2      byte  "program version",0
answer2 byte  "Porgram version 0.96",0

_3      byte  "program space",0
answer3 byte  "Program space used: 640 longs.",0

_4      byte  "total space", 0
answer4 byte  "Total program space is 8,000 longs, ranging from $0000 to $7FFF.", 0

_5      byte  "eeprom space", 0
answer5 byte  "Total EEPROM space is 16,000 longs, ranging from $0000 to $FFFE", 0

_7      byte  "reboot", 0


hlp     byte  "Help File", 13, 13
        byte  "F1-Help File", 13                     
        byte  "F2-User Tutorial", 13   
        byte  "F3-Reserved for future updates", 13
        byte  "F4-Reserved for future updates", 13
        byte  "Home-Info about program", 13                 
        byte  "End-Shut down Propeller", 13
        byte  "+-Form Feed", 0

tutor   byte  "User Tutorial", 13, 13
        byte  "When asking questions, always type in lowercase, followed by a CR.", 0